<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_TransportBookingRulesRQ StructType
 * @subpackage Structs
 */
class JP_TransportBookingRulesRQ extends AbstractStructBase
{
    /**
     * The Login
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Login
     */
    public $Login;
    /**
     * The Paxes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Paxes
     */
    public $Paxes;
    /**
     * The TransportBookingRulesRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_TransportBookingRulesRequest
     */
    public $TransportBookingRulesRequest;
    /**
     * The AdvancedOptions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_TransportBookingRulesAdvancedOptions
     */
    public $AdvancedOptions;
    /**
     * The RestrictedOptions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_RestrictedOptions
     */
    public $RestrictedOptions;
    /**
     * The AssignSeats
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_TransportAssignSeats
     */
    public $AssignSeats;
    /**
     * The Version
     * @var string
     */
    public $Version;
    /**
     * The Language
     * @var string
     */
    public $Language;
    /**
     * The TimeStamp
     * @var string
     */
    public $TimeStamp;
    /**
     * Constructor method for JP_TransportBookingRulesRQ
     * @uses JP_TransportBookingRulesRQ::setLogin()
     * @uses JP_TransportBookingRulesRQ::setPaxes()
     * @uses JP_TransportBookingRulesRQ::setTransportBookingRulesRequest()
     * @uses JP_TransportBookingRulesRQ::setAdvancedOptions()
     * @uses JP_TransportBookingRulesRQ::setRestrictedOptions()
     * @uses JP_TransportBookingRulesRQ::setAssignSeats()
     * @uses JP_TransportBookingRulesRQ::setVersion()
     * @uses JP_TransportBookingRulesRQ::setLanguage()
     * @uses JP_TransportBookingRulesRQ::setTimeStamp()
     * @param \StructType\JP_Login $login
     * @param \StructType\JP_Paxes $paxes
     * @param \StructType\JP_TransportBookingRulesRequest $transportBookingRulesRequest
     * @param \StructType\JP_TransportBookingRulesAdvancedOptions $advancedOptions
     * @param \StructType\JP_RestrictedOptions $restrictedOptions
     * @param \StructType\JP_TransportAssignSeats $assignSeats
     * @param string $version
     * @param string $language
     * @param string $timeStamp
     */
    public function __construct(\StructType\JP_Login $login = null, \StructType\JP_Paxes $paxes = null, \StructType\JP_TransportBookingRulesRequest $transportBookingRulesRequest = null, \StructType\JP_TransportBookingRulesAdvancedOptions $advancedOptions = null, \StructType\JP_RestrictedOptions $restrictedOptions = null, \StructType\JP_TransportAssignSeats $assignSeats = null, $version = null, $language = null, $timeStamp = null)
    {
        $this
            ->setLogin($login)
            ->setPaxes($paxes)
            ->setTransportBookingRulesRequest($transportBookingRulesRequest)
            ->setAdvancedOptions($advancedOptions)
            ->setRestrictedOptions($restrictedOptions)
            ->setAssignSeats($assignSeats)
            ->setVersion($version)
            ->setLanguage($language)
            ->setTimeStamp($timeStamp);
    }
    /**
     * Get Login value
     * @return \StructType\JP_Login|null
     */
    public function getLogin()
    {
        return $this->Login;
    }
    /**
     * Set Login value
     * @param \StructType\JP_Login $login
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setLogin(\StructType\JP_Login $login = null)
    {
        $this->Login = $login;
        return $this;
    }
    /**
     * Get Paxes value
     * @return \StructType\JP_Paxes|null
     */
    public function getPaxes()
    {
        return $this->Paxes;
    }
    /**
     * Set Paxes value
     * @param \StructType\JP_Paxes $paxes
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setPaxes(\StructType\JP_Paxes $paxes = null)
    {
        $this->Paxes = $paxes;
        return $this;
    }
    /**
     * Get TransportBookingRulesRequest value
     * @return \StructType\JP_TransportBookingRulesRequest|null
     */
    public function getTransportBookingRulesRequest()
    {
        return $this->TransportBookingRulesRequest;
    }
    /**
     * Set TransportBookingRulesRequest value
     * @param \StructType\JP_TransportBookingRulesRequest $transportBookingRulesRequest
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setTransportBookingRulesRequest(\StructType\JP_TransportBookingRulesRequest $transportBookingRulesRequest = null)
    {
        $this->TransportBookingRulesRequest = $transportBookingRulesRequest;
        return $this;
    }
    /**
     * Get AdvancedOptions value
     * @return \StructType\JP_TransportBookingRulesAdvancedOptions|null
     */
    public function getAdvancedOptions()
    {
        return $this->AdvancedOptions;
    }
    /**
     * Set AdvancedOptions value
     * @param \StructType\JP_TransportBookingRulesAdvancedOptions $advancedOptions
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setAdvancedOptions(\StructType\JP_TransportBookingRulesAdvancedOptions $advancedOptions = null)
    {
        $this->AdvancedOptions = $advancedOptions;
        return $this;
    }
    /**
     * Get RestrictedOptions value
     * @return \StructType\JP_RestrictedOptions|null
     */
    public function getRestrictedOptions()
    {
        return $this->RestrictedOptions;
    }
    /**
     * Set RestrictedOptions value
     * @param \StructType\JP_RestrictedOptions $restrictedOptions
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setRestrictedOptions(\StructType\JP_RestrictedOptions $restrictedOptions = null)
    {
        $this->RestrictedOptions = $restrictedOptions;
        return $this;
    }
    /**
     * Get AssignSeats value
     * @return \StructType\JP_TransportAssignSeats|null
     */
    public function getAssignSeats()
    {
        return $this->AssignSeats;
    }
    /**
     * Set AssignSeats value
     * @param \StructType\JP_TransportAssignSeats $assignSeats
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setAssignSeats(\StructType\JP_TransportAssignSeats $assignSeats = null)
    {
        $this->AssignSeats = $assignSeats;
        return $this;
    }
    /**
     * Get Version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->Version;
    }
    /**
     * Set Version value
     * @param string $version
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->Version = $version;
        return $this;
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($language, true), gettype($language)), __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
    /**
     * Get TimeStamp value
     * @return string|null
     */
    public function getTimeStamp()
    {
        return $this->TimeStamp;
    }
    /**
     * Set TimeStamp value
     * @param string $timeStamp
     * @return \StructType\JP_TransportBookingRulesRQ
     */
    public function setTimeStamp($timeStamp = null)
    {
        // validation for constraint: string
        if (!is_null($timeStamp) && !is_string($timeStamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeStamp, true), gettype($timeStamp)), __LINE__);
        }
        $this->TimeStamp = $timeStamp;
        return $this;
    }
}
